SystemOrganization addCategory: #'Refactoring-Tests-Critics'!

TestCase subclass: #RBSmalllintTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Tests-Critics'!

!RBSmalllintTest class methodsFor: 'accessing' stamp: 'lr 9/5/2010 10:48'!
packageNamesUnderTest
	^ #('Refactoring-Critics')! !

!RBSmalllintTest methodsFor: 'private' stamp: ''!
checkRule: aLintRule isEqualTo: anEnvironment 
	| returnedEnvironment |
	returnedEnvironment := aLintRule result.
	self compare: returnedEnvironment to: anEnvironment.
	self compare: anEnvironment to: returnedEnvironment! !

!RBSmalllintTest methodsFor: 'private' stamp: ''!
compare: subEnvironment to: superEnvironment 
	subEnvironment classesDo: 
			[:each | 
			(subEnvironment selectorsForClass: each) 
				do: [:sel | self assert: (superEnvironment includesSelector: sel in: each)]]! !

!RBSmalllintTest methodsFor: 'private' stamp: 'lr 12/24/2008 16:50'!
currentSelector
	^ testSelector! !

!RBSmalllintTest methodsFor: 'private' stamp: 'lr 2/26/2009 15:07'!
refactoryTestAppEnvironment
	| classEnvironment |
	classEnvironment := ClassEnvironment new.
	classEnvironment addClass: RBRefactoryTestDataApp.
	^ classEnvironment! !

!RBSmalllintTest methodsFor: 'private' stamp: 'lr 2/26/2009 16:10'!
ruleFor: aSelector 
	self ruleFor: aSelector plusSelectors: #()! !

!RBSmalllintTest methodsFor: 'private' stamp: 'lr 2/26/2009 16:11'!
ruleFor: aSelector plusSelectors: symbolCollection 
	| returnedEnvironment rule class selector className |
	selector := aSelector asString 
		copyFrom: 5
		to: aSelector size.
	className := 'RB' , selector , 'Rule'.
	class := Smalltalk classNamed: className.
	class isNil ifTrue: [ self error: className , ' class not found' ].
	selector 
		at: 1
		put: selector first asLowercase.
	selector := selector asSymbol.
	SmalllintChecker 
		runRule: (rule := class new)
		onEnvironment: self refactoryTestAppEnvironment.
	returnedEnvironment := SelectorEnvironment new.
	returnedEnvironment 
		addClass: RBRefactoryTestDataApp
		selector: selector.
	symbolCollection do: [ :each | 
		returnedEnvironment 
			addClass: RBRefactoryTestDataApp
			selector: each ].
	self 
		checkRule: rule
		isEqualTo: returnedEnvironment! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:13'!
testAsOrderedCollectionNotNeeded
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:13'!
testAssignmentInBlock
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testAssignmentInIfTrue
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:13'!
testAtIfAbsent
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testBadMessage
	self ruleFor: self currentSelector plusSelectors: #(cruft)! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testBooleanPrecedence
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testCollectSelectNotUsed
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testCollectionMessagesToExternalObject
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testCollectionProtocol
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:15'!
testConsistencyCheck
	self 
		ruleFor: self currentSelector
		plusSelectors: #(#noIsNil: )! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testContains
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testDetectContains
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testEndTrueFalse
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testEqualNotUsed
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testEqualsTrue
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:08'!
testEquivalentSuperclassMethods
	| returnedEnvironment rule |
	SmalllintChecker 
		runRule: (rule := RBEquivalentSuperclassMethodsRule new)
		onEnvironment: self refactoryTestAppEnvironment.
	returnedEnvironment := SelectorEnvironment new.
	returnedEnvironment 
		addClass: RBRefactoryTestDataApp
		selector: #isLiteral.
	self 
		checkRule: rule
		isEqualTo: returnedEnvironment! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:15'!
testExtraBlock
	self 
		ruleFor: self currentSelector
		plusSelectors: #(#testMethod1 )! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testFileBlocks
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'bh 4/8/2000 19:06'!
testFullBlocks
	"skip this test in squeak"

"	self blockRuleFor: self currentSelector
		plusSelectors: #(#caller1 #fullBlocks #detectContains #fileBlocks #moveDefinition #caller #assignmentInBlock #equalNotUsed #stringConcatenation #noMoveDefinition #referencesConditionFor: #returnInEnsure)"! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testGuardingClause
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testIfTrueBlocks
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testIfTrueReturns
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testJustSendsSuper
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testLiteralArrayCharacters
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testLongMethods
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testMinMax
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:15'!
testMissingYourself
	self 
		ruleFor: self currentSelector
		plusSelectors: #(#inlineMethod )! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testModifiesCollection
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testPrecedence
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testRefersToClass
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testReturnInEnsure
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testReturnsBooleanAndOther
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testReturnsIfTrue
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testSearchingLiteral
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testSendsDifferentSuper
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testSizeCheck
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testStringConcatenation
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testTempVarOverridesInstVar
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:12'!
testTempsReadBeforeWritten
	self ruleFor: self currentSelector
		plusSelectors: #(#inlineTemporary #noMoveDefinition #tempsReadBeforeWritten #equalNotUsed #fileBlocks #referencesConditionFor:)! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testThreeElementPoint
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testToDo
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testToDoCollect
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testToDoWithIncrement
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testUsesAdd
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testWhileTrue
	self ruleFor: self currentSelector! !

!RBSmalllintTest methodsFor: 'tests' stamp: 'lr 2/26/2009 16:14'!
testYourselfNotUsed
	self ruleFor: self currentSelector! !
